bool VT::GetTmpGenoMatrixPED(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum)
{
   double mac =0.0;
   bool status = false;
   tmpGenoMatrix.Dimension(0,0);
   mafIncluded.Clear();
   numVarPerGene=0;

   StringArray SNPNameList;
   for(int m=0;m<group.chrList[groupNum].Length();m++)
   {
      String markerName = group.chrList[groupNum][m];
      markerName += ":";
      markerName += group.posList[groupNum][m];
      SNPNameList.Push(markerName);
   }
   //Now filter by maf calculated from pedigree file
   Vector freq;
   int minor,markerid;
   IntArray key,minorAllele;
   int length = SNPNameList.Length();
   SNPcount = 0;
   for(int m=0;m<length;m++)
   {
      markerid = ped.markerLookup.Integer(SNPNameList[m]);
      //markerid = ped.GetMarkerID(SNPNameList[m]);
      if(markerid==-1)
      {
	 continue;
      }
      if(SVT::FounderFreq)
	 bool tmpF=EstimateFrequencies(ped,markerid,FREQ_FOUNDERS);
      else
	 bool tmpF=EstimateFrequencies(ped,markerid,FREQ_ALL);

      freq.Copy(ped.GetMarkerInfo(markerid)->freq);

      markerMaf = 0.0;
      if(freq.Length()==3)
      {
	 if(freq[1] < freq[2]) { minor=1; markerMaf = freq[1]; }
	 else { minor=2; markerMaf = freq[2];}
	 if(markerMaf> mafMin && markerMaf <= mafMax)
	 {
	    key.Push(markerid);
	    minorAllele.Push(minor);
	    mafIncluded.Push(markerMaf);
	    //         mafSqrIncluded.Push(markerMaf*markerMaf);
	    numVarPerGene++;
	    SNPcount++;

	    if(fullResult)
	    {
	       String tmp = SNPNameList[m] + ";";
	       varsIncluded += tmp;
	    }
	    // printf("marker name is:%s\n",SNPNameList[m].c_str());
	 }
      } //Now qualified SNPs are in key.
   }
   bool XStatus = false;

   if(key.Length()==0) goto skip_to_point;

   if(AutoFit::fitX)
   {
      String markerName = ped.markerNames[markerid];
      int found = ped.markerNames[markerid].FastFindChar('X',0);
      StringArray tmp;
      tmp.AddTokens(markerName,":");
      if(found!=-1)
      {
	 if(atoi(tmp[1].c_str()) > SVT::Xstart && atoi(tmp[1].c_str())< SVT::Xend)
	 {
	    XStatus=true;
	 }
      }
   }

   tmpGenoMatrix.GrowTo(trans.persons,tmpGenoMatrix.cols+1,0.0);
   if(VTwtCMC_counts || VTwtCMC_binary)
   {
      int idx=0;
      mac=0.0;
      for(int f=0;f<ped.familyCount;f++)
      {
	 for(int p=0;p<trans.pPheno[f].Length();p++)
	 {
	    for(int m=0; m<key.Length(); m++)
	    {
	       if(!ped[trans.pPheno[f][p]].isGenotyped(key[m]))
	       {
		  tmpGenoMatrix[idx][numVarPerGene-1] += 2.0*mafIncluded[m];
		  mac+=2.0;
	       }
	       else if(ped[trans.pPheno[f][p]].markers[key[m]].isHeterozygous())
	       {
		  if(XStatus)
		  {
		     if(ped[trans.pPheno[f][p]].sex==2)
		     {
			tmpGenoMatrix[idx][numVarPerGene-1] += 1;
			status=true;
		     }
		     if(ped[trans.pPheno[f][p]].sex==1)
		     {
			tmpGenoMatrix[idx][numVarPerGene-1] += 2;
			status=true;
		     }
		  }
		  else
		  {
		     tmpGenoMatrix[idx][numVarPerGene-1] += 1;
		     mac+=1.0;
		     status=true;
		  }
	       }
	       else if(ped[trans.pPheno[f][p]].markers[key[m]].isHomozygous() && ped[trans.pPheno[f][p]].markers[key[m]].hasAllele(minorAllele[m]))
	       {
		  tmpGenoMatrix[idx][numVarPerGene-1] += 2;
		  mac+=2.0;
		  status=true;
	       }
	    }
	    idx++;
	 }
      }
   }
skip_to_point:
   if(mac<MAC)
      status = false;
   return status;
}

bool VT::GetTmpGenoMatrixDosage(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum)
{
   double mac =0.0;
   bool status = false;
   tmpGenoMatrix.Dimension(0,0);
   mafIncluded.Dimension(0);

   int numSamples = header.getNumSamples();

   reader.set1BasedReadSection(group.chrList[groupNum][0].c_str(),group.posList[groupNum][0],group.posList[groupNum][group.posList[groupNum].Length()-1]+1);
   int m=0;
   while(reader.readRecord(record))
   {
      int position = record.get1BasedPosition();
      String altAllele = record.getAltStr();
      String refAllele = record.getRefStr();
      if(group.posList[groupNum][m]!=position)
      {
	 continue;
      }
      else
      {
	 String allele = refAllele + "/" + altAllele;
	 if(allele != group.alleleList[groupNum][m])
	 {
	    String flipAllele = altAllele + "/" + refAllele;
	    if(flipAllele != group.alleleList[groupNum][m])
	       continue;
	    else
	    {
	       //TODO:ref and alt are flipped. need to take that into account when calculating genotypes.
	       //TODO: maybe good for t2dgenes, but not good for others
	       printf("ref and alt alleles are flipped!");
	    }
	 }
      }
      //If the variant match the record in groupfile then add up m to next variant. 
      //This requires varaints in group file has to be sorted.
      m++;
      if(m==group.chrList[groupNum].Length())
	 break;

      int n=0,nf=0;
      double fmaf = 0.0, maf=0.0;
      VcfRecordGenotype & genoInfo = record.getGenotypeInfo();

      //Loop througth all samples to calculate maf
      for(int s=0;s<numSamples;s++)
      {
	 const std::string * geno = genoInfo.getString("DS",s);
	 const char * sample = header.getSampleName(s);

	 if(geno==NULL)
	 {
	    error("Error: Can not find DS field for sample %d ...",s);
	 }
	 if(*geno == ".")
	 {
	    continue;
	 }
	 float dose = atof((*geno).c_str());

	 //judge if this is a founder
	 int founder = trans.foundersHash.Integer(sample);
	 if(founder != -1)
	 {
	    fmaf += dose;
	    nf++;
	 }
	 maf += dose;
	 n++;
      }
      if(n!=0)
	 maf /= 2.0*n;
      else
	 continue;

      if(nf!=0)
	 fmaf /= 2.0*nf;
      else
	 fmaf=maf;
      if(maf==0.0)
      {
	 fmaf = 0.0;
      }
      if(fmaf==0.0 && maf>0)
	 fmaf = maf;

      if(maf==0.0)
	 continue;

      if(fmaf>0.5) fmaf = 1.0-fmaf;
      if(maf>0.5) maf = 1.0-maf;

      //check if maf falls into the range
      if(SVT::FounderFreq)
      {
	 if(fmaf>mafMax || fmaf<mafMin)
	    continue;
      }
      else
      {
	 if(maf>mafMax || maf<mafMin)
	    continue;
      }
      numVarPerGene++;

      if(fullResult)
      {
	 String tmp = "";
	 tmp += group.chrList[groupNum][m];
	 tmp+=":";
	 tmp+=group.posList[groupNum][m];
	 tmp+= "_";
	 tmp+=refAllele;
	 tmp+= "/";
	 tmp+=  altAllele;
	 tmp+=  ";";
	 varsIncluded += tmp;
      }

      if(SVT::FounderFreq)
      {
	 mafIncluded.Push(fmaf);
      }
      else
      {
	 mafIncluded.Push(maf);
      }

      tmpGenoMatrix.GrowTo(trans.persons,tmpGenoMatrix.cols+1,0.0);

      //update the genotype matrix
      int idx=0;
      for (int f = 0; f < ped.familyCount; f++)
      {
	 for(int j=0;j<trans.pPheno[f].Length();j++)
	 {
	    String sample = ped[trans.pPheno[f][j]].pid.c_str();

	    //get the sample number by sample ID from hash
	    int s = trans.sampleVCFIDHash.Integer(sample);
	    if(s!=-1)
	    {
	       const std::string * geno = genoInfo.getString("DS",s);
	       if(strcmp((*geno).c_str(),".")>0)
	       {
		  float dose = atof((*geno).c_str());
		  if(dose>0)
		  {
		     status=true;
		     if(CMC_binary)
		     {
			tmpGenoMatrix[idx][numVarPerGene-1] = 1;
		     }
		     if(CMC_counts)
		     {
			tmpGenoMatrix[idx][numVarPerGene-1] +=dose;
		     }
		     if(MB)
		     {
			tmpGenoMatrix[idx][numVarPerGene-1] += dose/sqrt(mafIncluded[numVarPerGene-1]*(1.0-mafIncluded[numVarPerGene-1]));
		     }
		     mac += dose;
		  }
	       }
	    }
	    idx++;
	 }
      }
   }
   if(numVarPerGene==0)
   {
      status =false;
      return status;
   }
   if(mac<MAC)
   {
      status = false;
      return status;
   }
   //work on mafIncluded to get unique cutoffs
   Vector cp_mafIncluded;
   cp_mafIncluded.Copy(mafIncluded);
   cp_mafIncluded.Sort();
   unique_maf.Clear();
   unique_maf.Push(cp_mafIncluded[0]);
   for(int i=1;i<cp_mafIncluded.Length();i++)
   {
      if(cp_mafIncluded[i]>unique_maf[unique_maf.Length()-1])
	 unique_maf.Push(cp_mafIncluded[i]);
   } //now unique maf cutoffs are saved in unique_maf.
   return status;
}

bool VT::GetTmpGenoMatrixVCF(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum)
{}

bool VT::GetTmpGenoMatrixPED(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum)
{}

bool VT::GetGenotypeMatrix(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum)
{
   bool status = false;

   if(SVT::genoFromPed)
      status = GetGenotypeVectorPED(trans,ped,group,groupNum);
   if(SVT::genoFromVCF)
      status = GetGenotypeVectorVCF(trans,ped,group,groupNum);
   if(SVT::dosage)
      status = GetTmpGenoMatrixDosage(trans,ped,group,groupNum);
   if(!status)
      return status;
}

bool VT::FinalizeGenoMatrix(FastTransform & trans,bool reduceDimension)
{

   if(reduceDimension)
   {
      while(unique_maf.Length()>20)
      {
	 unique_maf.Delete[0];
      }
   }

   genotypeMatrix.Dimension(trans.persons,unique_maf.Length());

   for(int j=0;j<unique_maf.Length();j++)
   {
      for(int i=0;i<mafIncluded.Length();i++)
      {
	 if(mafIncluded[i]<unique_maf[j])
	 {
	    for(int p=0;p<trans.persons;p++)
	    {
	       genotypeMatrix[p][j] += tmpGenoMatrix[p][i];
	    }
	 }
      }

      if(VTwtCMC_binary)
      {
	 for(int p=0;p<trans.persons;p++)
	 {  
	    if(genotypeMatrix[p][j]>0.0)
	       genotypeMatrix[p][j] = 1.0;
	 }
      }
   }

   //adjusting mean
   for(int c=0;c<genotypeMatrix.cols;c++)
   {
      double mean =0.0;
      for(int r=0;r<trans.persons;r++)
      {
	 mean += genotypeMatrix[r][c];
      }
      if(mean ==0.0)
	 del.Push(c);
      else
      {
	 mean /= trans.persons;
	 for(int r=0;r<trans.persons;r++)
	 {
	    genotypeMatrix[r][c] -= mean;
	 }
      }
   }
   if(del.Length()>0)
      for(int i=0;i<del.Length();i++)
      {
	 genotypeMatrix.DeleteColumn(del[i]-i);
      }
}
